package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TABLE_COVERED_TABLE_CELL;
import static w2phtml.office.XMLString.TABLE_TABLE_CELL;
import static w2phtml.office.XMLString.TEXT_P;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class TableRowSplitter extends BasicSplitter implements ISplitter {

	public TableRowSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
	}

	@Override
	public SplitResults Split(Node tableRow) {
		Node tableRowFirstPart = tableRow.cloneNode(false);
		Node parent = tableRow.getParentNode();
		SplitResults results = new SplitResults(false);
		// Node counter
		int i = 0;
		NodeList tableRowChildNodes = tableRow.getChildNodes();
		while (tableRowChildNodes.getLength() > i) {
			Node tableRowChildNode = tableRowChildNodes.item(i);
			if ((tableRowChildNode.getNodeType() == Node.ELEMENT_NODE)) {
				
				String nodeName = tableRowChildNode.getNodeName();
				
				if (containsSPB(tableRowChildNode)){
					if (nodeName.equals(TABLE_TABLE_CELL)){
						if (factory.split(tableRowChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowFirstPart.appendChild(tableRowChildNode.getPreviousSibling());
						}
					
					} else if (nodeName.equals(TABLE_COVERED_TABLE_CELL)){
						//Implement handleCoveredCell in future
						if (factory.split(tableRowChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowFirstPart.appendChild(tableRowChildNode.getPreviousSibling());
						}
					} 
				} else {
					//System.out.println("HERE " + nodeName);
					//Move node without SPB above
					tableRowFirstPart.appendChild(tableRowChildNode.cloneNode(true));
					Node emptyCell = tableRowChildNode.cloneNode(false);
					Document document = tableRow.getOwnerDocument();
					Element textP = document.createElement(TEXT_P);
					emptyCell.appendChild(textP);
					tableRow.insertBefore(emptyCell, tableRowChildNode);
					tableRow.removeChild(tableRowChildNode);
					
					
					results.setDataMoved(true);
				}
				i++;
			} else {
				System.out.println("ERROR: TEXT NODE FOUND INSIDE tabl:table-row");
				//Append text nodes
				//tableRowsFistPart.appendChild(tableRowsChildNode);
				//dataMoved = true;	
			}
			
		}
		if (results.isDataMoved()) {
			parent.insertBefore(tableRowFirstPart, tableRow);
		}
		return results;
	}

}
